#ifndef LCD_CLOCK_H
#define LCD_CLOCK_H 1


/* Global variable used to control the LCD display. Making changes to
   this variable will change the clock time */
extern int LCD_DISPLAY_PORT;

/* Time of day in seconds; set by the hardward, read only */
extern int TIME_OF_DAY_SEC;

/* Convenience struct for representing the LCD clock as characters */
typedef struct {
  char chars[5][32];
} lcd_display;

/* Use the global LCD_DISPLAY_PORT to print the time */
void print_lcd_clock();

void showbits(int x);

#endif
