#include <stdlib.h>
#include <stdio.h>
#include "hw6.h"

int main(){
  {
    char *fname = "channel_params1.dat";
    int n_ca =        5;
    channel_params ca[5] = {
      {.channel=10 , .frequency=2.457e9, .phase=0.5},
      {.channel=11 , .frequency=2.462e9, .phase=0.5},
      {.channel= 2 , .frequency=2.417e9, .phase=0.5},
      {.channel= 3 , .frequency=2.422e9, .phase=0.5},
      {.channel= 4 , .frequency=2.427e9, .phase=0.5},
    };
    int i;
    printf("Saving %d channel_params to   file %s\n",n_ca,fname);
    for(i=0; i<n_ca; i++){
      printf("ca[%2d] =     { .channel=%2d, .frequency=%.3e, .phase=%.2lf }\n",
             i, ca[i].channel, ca[i].frequency, ca[i].phase);
    }
    
    save_channel_params(fname,ca,n_ca);

    printf("\nReloading channel_params from file %s\n",fname);

    int n_loaded = -1;
    channel_params *loaded = load_channel_params(fname, &n_loaded);
    printf("Loaded %d channel_params\n",n_loaded);
    for(i=0; i<n_loaded; i++){
      printf("loaded[%2d] = { .channel=%2d, .frequency=%.3e, .phase=%.2lf }\n",
             i, loaded[i].channel, loaded[i].frequency, loaded[i].phase);
    }
    free(loaded);
    printf("\n");
  }
  {
    char *fname = "channel_params2.dat";
    int n_ca =        12;
    channel_params ca[12] = {
      {.channel= 2 , .frequency=2.417e9, .phase=0.0},
      {.channel= 3 , .frequency=2.422e9, .phase=0.0},
      {.channel= 4 , .frequency=2.427e9, .phase=0.0},
      {.channel= 2 , .frequency=2.417e9, .phase=0.25},
      {.channel= 3 , .frequency=2.422e9, .phase=0.25},
      {.channel= 4 , .frequency=2.427e9, .phase=0.25},
      {.channel= 2 , .frequency=2.417e9, .phase=0.50},
      {.channel= 3 , .frequency=2.422e9, .phase=0.50},
      {.channel= 4 , .frequency=2.427e9, .phase=0.50},
      {.channel= 2 , .frequency=2.417e9, .phase=0.75},
      {.channel= 3 , .frequency=2.422e9, .phase=0.75},
      {.channel= 4 , .frequency=2.427e9, .phase=0.75},
    };
    int i;
    printf("Saving %d channel_params to   file %s\n",n_ca,fname);
    for(i=0; i<n_ca; i++){
      printf("ca[%2d] =     { .channel=%2d, .frequency=%.3e, .phase=%.2lf }\n",
             i, ca[i].channel, ca[i].frequency, ca[i].phase);
    }
    
    save_channel_params(fname,ca,n_ca);

    printf("\nReloading channel_params from file %s\n",fname);

    int n_loaded = -1;
    channel_params *loaded = load_channel_params(fname, &n_loaded);
    printf("Loaded %d channel_params\n",n_loaded);
    for(i=0; i<n_loaded; i++){
      printf("loaded[%2d] = { .channel=%2d, .frequency=%.3e, .phase=%.2lf }\n",
             i, loaded[i].channel, loaded[i].frequency, loaded[i].phase);
    }
    free(loaded);
    printf("\n");
  }
  {
    char *fname = "channel_params3.dat";
    int n_ca =        15;
    channel_params ca[15] = {
      {.channel= 4, .frequency=2.427e+09, .phase= -0.80},
      {.channel= 2, .frequency=2.417e+09, .phase= -0.80},
      {.channel= 3, .frequency=2.422e+09, .phase= -0.80},
      {.channel= 4, .frequency=2.427e+09, .phase=  1.25},
      {.channel= 2, .frequency=2.417e+09, .phase=  1.25},
      {.channel= 3, .frequency=2.422e+09, .phase=  1.25},
      {.channel= 4, .frequency=2.427e+09, .phase=  0.50},
      {.channel= 2, .frequency=2.417e+09, .phase=  0.50},
      {.channel= 3, .frequency=2.422e+09, .phase=  0.50},
      {.channel= 4, .frequency=2.427e+09, .phase= -0.75},
      {.channel= 2, .frequency=2.417e+09, .phase= -0.75},
      {.channel= 3, .frequency=2.422e+09, .phase= -0.75},
      {.channel= 4, .frequency=2.427e+09, .phase=  1.50},
      {.channel= 2, .frequency=2.417e+09, .phase=  1.50},
      {.channel= 3, .frequency=2.422e+09, .phase=  1.50},
    };
    int i;
    printf("Saving %d channel_params to   file %s\n",n_ca,fname);
    for(i=0; i<n_ca; i++){
      printf("ca[%2d] =     { .channel=%2d, .frequency=%.3e, .phase=%.2lf }\n",
             i, ca[i].channel, ca[i].frequency, ca[i].phase);
    }
    
    save_channel_params(fname,ca,n_ca);

    printf("\nReloading channel_params from file %s\n",fname);

    int n_loaded = -1;
    channel_params *loaded = load_channel_params(fname, &n_loaded);
    printf("Loaded %d channel_params\n",n_loaded);
    for(i=0; i<n_loaded; i++){
      printf("loaded[%2d] = { .channel=%2d, .frequency=%.3e, .phase=%.2lf }\n",
             i, loaded[i].channel, loaded[i].frequency, loaded[i].phase);
    }
    free(loaded);
    printf("\n");
  }
  {
    int i;
    char *fname = "sample_channels1.dat";
    printf("\nLoading channel_params from file %s\n",fname);

    int n_loaded = -1;
    channel_params *loaded = load_channel_params(fname, &n_loaded);
    printf("Loaded %d channel_params\n",n_loaded);
    for(i=0; i<n_loaded; i++){
      printf("loaded[%2d] = { .channel=%2d, .frequency=%.3e, .phase=%.2lf }\n",
             i, loaded[i].channel, loaded[i].frequency, loaded[i].phase);
    }
    free(loaded);
    printf("\n");
  }
  {
    int i;
    char *fname = "sample_channels2.dat";
    printf("\nLoading channel_params from file %s\n",fname);

    int n_loaded = -1;
    channel_params *loaded = load_channel_params(fname, &n_loaded);
    printf("Loaded %d channel_params\n",n_loaded);
    for(i=0; i<n_loaded; i++){
      printf("loaded[%2d] = { .channel=%2d, .frequency=%.3e, .phase=%.2lf }\n",
             i, loaded[i].channel, loaded[i].frequency, loaded[i].phase);
    }
    free(loaded);
    printf("\n");
  }

  return 0;
}
