#include "int_list.h"
#include "hw6.h"
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv){
  int_list *list = int_list_create();
  int i;
  for(i=argc-1; i>=1; i--){
    int_list_prepend(list, atoi(argv[i]));
  }
  printf("List: ");  int_list_print(list, stdout); printf("\n");

  int status=1, index, data;
  while(status != EOF){
    printf("Enter insert index and new data, both ints (Ctrl-D to quit):\n");
    status = scanf("%d %d", &index, &data);
    if(status != EOF){
      if(index >= 0){           /* insertion */
        /* Insert into the list */
        int success = int_list_insert(list, index, data);
        printf("int_list_insert(list,%d,%d) returned %d\n",index,data,success);
      }
      else{                     /* removal */
        index = -(index+1);
        int success = int_list_remove(list, index);
        printf("int_list_remove(list,%d) returned %d\n",index,success);
      }
      printf("List: ");  int_list_print(list, stdout); printf("\n");
      printf("\n");

    }
    
  }
  int_list_destroy(list);
  return 0;
}
